> ## Documentation Index
> Fetch the complete documentation index at: https://docs.busha.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Activate a draft invoice

> Transitions an invoice from draft status to active and sends email notification to customer



## OpenAPI

````yaml https://raw.githubusercontent.com/bushaHQ/openapi/refs/heads/main/openapi-spec.yaml post /v1/payments/links/{id}/activate
openapi: 3.0.0
info:
  title: Busha API
  contact:
    email: developers@busha.co
  description: >
    ## Introduction

    The **Busha API** is designed to provide businesses with tools for
    borderless financial transactions and operations, enabling modern, global
    money management. It serves as the backbone for facilitating:

    - Creation and management of multi-currency balances

    - Retrieval of real-time cryptocurrency rates

    - Substantial data insights for business owners


    Whether you’re a product-driven fintech or a developer building
    integrations, this API significantly accelerates implementation while
    reducing financial complexities.

    For detailed guides on API integration, visit our [official
    documentation]().



    ## Authentication

    All API requests require a **Bearer Token** for authentication, passed in
    the `Authorization` header.

    Your authorization value is a base64 encoded value of your api key and your
    secret key.

    You can obtain API tokens via your Busha user or business account.
    Authentication is mandatory to ensure secure and authorized interactions
    with the API.

    The API keys from the dashboard provides a base64 encoding of the your
    authorization tokens.


    Your generated Key should look like this:

    `VURtNXhWcHueantkpaiewjo0S044MWsadfojienuoxRTiWDJaeWJaTGxxanZ3Ym10OU1RZnVWajVW=`


    Example Header:

    ``` curl

    Authorization: Bearer
    VURtNXhWcHueantkpaiewjo0S044MWsadfojienuoxRTiWDJaeWJaTGxxanZ3Ym10OU1RZnVWajVW=

    ```


    ## Error Handling

    #Standardized error responses ensure predictable interactions. Errors are
    detailed for easy debugging and understanding:

    | **Error Code** | **HTTP Status Code** | **Description** |

    | --- | --- | --- |

    | `bad_request` | 400 | Invalid input or malformed request |

    | `unauthorized` | 401 | Invalid or missing authentication |

    | `not_found` | 404 | Resource not found |

    | `service_unavailable` | 503 | Server error |


    Basic Error Example:

    ``` json

    {
      "error": {
        "name": "bad_request",
        "message": "Invalid input data"
      }
    }

    ```


    Schema Error Body Example:

    ``` json

    {
      "error": {
        "name": "bad_request",
        "message": "Invalid input data"
      },
      "schema": {
        "reason": "The request body is defined as an object. However, it does not meet the schema requirements of the specification",
        "fix": "Ensure that the object being submitted, matches the schema correctly"
      }
    }

    ```


    Field Error Body Example:

    ``` json

    {
      "error": {
        "name": "bad_request",
        "message": "Invalid input data"
      },
      "fields": {
        "field1": [
          {
            "reason": "The request body is defined as an object. However, it does not meet the schema requirements of the specification",
          },
        ],
        "field2": [
          {
            "reason": "The request body is defined as an object. However, it does not meet the schema requirements of the specification",
          }
        ],
      }
    }

    ```


    ## Pagination

    Pagination uses cursors provided as:

    The API supports **cursor-based pagination** for endpoints with large
    datasets. Pagination uses a `next_cursor` and `previous_cursor` returned in
    the response.

    Example Response Format:

    ``` json

    {
      "current_entries_size": 10,
      "next_cursor": "base64_cursor_value",
      "previous_cursor": "base64_previous_cursor_value"
    }

    ```


    ## Rate Limiting

    Rate limits determine how many API calls can be made in a rolling minute.
    This ensures fair and optimized use of system resources.


    The rate limits allowed by each resource will be provided with the header:

    ```curl

    x-rate-limit 100

    ```

    If this header does not exist, then the rate limit is set at a default 100
    req/min


    Requests exceeding the allocated quota will receive a `429 Too Many
    Requests` response.


    ##  Common Parameters

    Common parameters enhance consistency across endpoints:
      | **Parameter Name** | **Location** | **Description** | **Example** |
      | --- | --- | --- | --- |
      | `X-BU-PROFILE-ID` | Header | User profile identifier | `BUS_qwejinoiuiqw93ejjw` |
      | `id` | Path | Unique NanoID identifier | `dpt_jweqafajsndiun34fd` |
      | `cursor` | Query | Pagination cursor | `base64_cursor_string` |

    #### Paginated Response Example
      ``` json
      {
        "status": "success",
        "message": "Data retrieved",
        "pagination": {
          "next_cursor": "value_for_next_page",
          "current_entries_size": 20
        },
        "data": [...]
      }
      ```
  version: 1.0.0
servers:
  - url: https://api.sandbox.busha.so
    description: Sandbox Environment
  - url: https://api.busha.io
    description: Production Environment
security: []
tags:
  - name: Balances
    description: Handles account balances across different currencies.
    x-displayName: Balances
  - name: Bills
    description: Lorem Ipsum
    x-displayName: Bills
  - name: Cards
    description: Lorem Ipsum
    x-displayName: Cards
  - name: Cashback
    description: Main tag for cashback service endpoints
    x-displayName: Cashback
  - name: Currencies
    description: >
      Endpoints to manage supported currencies, their properties, and network
      details.
    x-displayName: Currencies
  - name: Customers
    x-internal: false
    description: Handle customer requests and responses
    x-displayName: Customers
  - name: Files
    description: Provides APIs to handle files upload
    x-displayName: Files
  - name: Mandate
    x-displayName: Mandate
  - name: Miscellaneous
    description: Provides auxiliary APIs to complement and enhance other services.
    x-displayName: Miscellaneous
  - name: News
    description: News article endpoints
    x-displayName: News
  - name: Pairs
    description: Access trading pair information and rates
    x-displayName: Pairs
  - name: PaymentLinks
    description: Payment Links
    x-displayName: PaymentLinks
  - name: PaymentRequests
    description: Payment request
    x-displayName: PaymentRequests
  - name: PriceAlerts
    description: Price alert management endpoints
    x-displayName: PriceAlerts
  - name: Quotes
    description: Handle quotes requests and responses
    x-displayName: Quotes
  - name: Recipients
    x-displayName: Recipients
  - name: Transactions
    x-displayName: Transactions
  - name: Transfers
    x-displayName: Transfers
  - name: Widget
    description: Widget operations
    x-displayName: Widget
paths:
  /v1/payments/links/{id}/activate:
    post:
      tags:
        - PaymentLinks
      summary: Activate a draft invoice
      description: >-
        Transitions an invoice from draft status to active and sends email
        notification to customer
      operationId: activateInvoice
      parameters:
        - $ref: '#/components/parameters/PathParamNanoID'
        - $ref: '#/components/parameters/ProfileHeader'
      responses:
        '200':
          description: Invoice activated successfully
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/BaseSchema'
                  - type: object
                    required:
                      - data
                    properties:
                      data:
                        $ref: '#/components/schemas/PaymentLink'
        4XX:
          $ref: '#/components/responses/PaymentLinkError4XX'
        5XX:
          $ref: '#/components/responses/PaymentLinkError5XX'
      security:
        - Auth:
            - transfers:write
            - api:write
components:
  parameters:
    PathParamNanoID:
      in: path
      name: id
      required: true
      schema:
        type: string
        format: nanoid
        example: bus_123456789
      x-oapi-codegen-extra-tags:
        validate: required|nanoid
    ProfileHeader:
      in: header
      name: X-BU-PROFILE-ID
      required: false
      description: User profile header
      schema:
        type: string
        example: BUS_YOK8tp5Zga01qOKEsqp07
  schemas:
    BaseSchema:
      description: General response Values
      type: object
      required:
        - status
        - message
      properties:
        status:
          type: string
          x-order: 1
          x-go-type: string
          enum:
            - success
            - error
          example: success
        message:
          type: string
          x-order: 2
          example: message for success
    PaymentLink:
      type: object
      required:
        - id
        - profile_id
        - type
        - fixed
        - one_time
        - name
        - link
        - title
        - description
        - target_currency
        - status
        - created_at
        - updated_at
      properties:
        id:
          $ref: '#/components/schemas/NanoID'
        profile_id:
          $ref: '#/components/schemas/NanoID'
        type:
          $ref: '#/components/schemas/PaymentLinkType'
          x-order: 2
        fixed:
          x-order: 3
          type: boolean
          example: false
          description: >
            If true it will use the fixed amount, otherwise it will use the
            dynamic amount
        one_time:
          x-order: 4
          type: boolean
          example: false
          description: |
            If true it is a one-time link, otherwise it is a reusable link
        link:
          type: string
          format: url
          example: https://pay.busha.io/charges/123456789
        name:
          x-order: 5
          type: string
          example: Payment Link
        title:
          x-order: 6
          type: string
          description: |
            The display title shown to customers
        description:
          x-order: 7
          type: string
          description: |
            The display description shown to customers
        quote_amount:
          x-order: 8
          allOf:
            - $ref: '#/components/schemas/Decimal'
          description: >
            The amount to be paid for the product/service pegged to the quote
            currency
        quote_currency:
          x-order: 9
          allOf:
            - $ref: '#/components/schemas/Currency'
          description: >
            The currency used to price the amount, which is converted from the
            source amount
        target_amount:
          x-order: 10
          allOf:
            - $ref: '#/components/schemas/Decimal'
          description: >
            The amount to be paid for the product/service in a crypto currency
            (target currency)
        target_currency:
          x-order: 11
          allOf:
            - $ref: '#/components/schemas/Currency'
          description: |
            The crypto currency to which payment is to be received in
        meta:
          x-order: 12
          allOf:
            - $ref: '#/components/schemas/PaymentLinkMeta'
        status:
          x-order: 13
          allOf:
            - $ref: '#/components/schemas/PaymentLinkStatus'
        pub_key:
          type: string
        created_at:
          x-order: 14
          allOf:
            - $ref: '#/components/schemas/TimeStamp'
        updated_at:
          x-order: 15
          allOf:
            - $ref: '#/components/schemas/TimeStamp'
        expires_at:
          x-order: 16
          allOf:
            - $ref: '#/components/schemas/TimeStamp'
    NanoID:
      type: string
      x-order: 2
      example: bus_123456789
      format: nanoid
      description: A valid id
      x-oapi-codegen-extra-tags:
        validate: required|nanoid
    PaymentLinkType:
      type: string
      enum:
        - payment_link
        - invoice
    Decimal:
      type: string
      description: decimal value
      example: '100'
      x-go-type: decimal.Decimal
      x-go-type-import:
        path: github.com/shopspring/decimal
        name: decimal
    Currency:
      type: string
      x-order: 20
      example: BTC
      format: string
      maxLength: 10
      minLength: 1
      description: A valid currency
      x-oapi-codegen-extra-tags:
        validate: required|min_len:1|max_len:10
        filter: trim|upper
    PaymentLinkMeta:
      type: object
      properties:
        images:
          type: array
          items:
            type: string
            format: url
        allow_customer_amount:
          type: boolean
        amount_limit:
          $ref: '#/components/schemas/AmountLimit'
        allow_quantity_selection:
          type: boolean
        require_extra_info:
          type: array
          items:
            $ref: '#/components/schemas/PaymentLinkExtraInfo'
        customer_email:
          type: string
          format: email
          description: Customer email for invoices
        customer_name:
          type: string
          description: Customer name for invoices
        due_date:
          type: string
          format: date-time
          description: Due date for invoices
        note:
          type: string
          maxLength: 250
          description: Optional note for invoices
        items:
          type: array
          items:
            $ref: '#/components/schemas/InvoiceItem'
    PaymentLinkStatus:
      type: string
      enum:
        - draft
        - pending
        - active
        - expired
        - deleted
        - paid
    TimeStamp:
      type: string
      format: date-time
      example: '2023-10-15T12:15:30Z'
      x-go-type: time.Time
    ErrorResponse:
      type: object
      required:
        - error
      properties:
        error:
          type: object
          required:
            - name
            - message
          properties:
            name:
              type: string
              x-order: 40
              example: bad_request
            message:
              type: string
              example: Invalid Request
        fields:
          type: object
        schema:
          type: array
          items:
            type: object
      example:
        error:
          name: bad_request
          message: Invalid Request
    AmountLimit:
      type: object
      required:
        - min_amount
        - max_amount
      properties:
        min_amount:
          $ref: '#/components/schemas/Decimal'
        max_amount:
          $ref: '#/components/schemas/Decimal'
    PaymentLinkExtraInfo:
      type: object
      required:
        - field_name
        - required
      properties:
        field_name:
          type: string
        required:
          type: boolean
    InvoiceItem:
      type: object
      required:
        - item
        - quantity
        - amount
      properties:
        item:
          type: string
          description: Name/description of the item
          maxLength: 255
        quantity:
          type: integer
          description: Quantity of the item
          minimum: 1
        amount:
          $ref: '#/components/schemas/Decimal'
          description: Unit price of the item
  responses:
    PaymentLinkError4XX:
      description: Default
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
          examples:
            default:
              $ref: '#/components/examples/DefaultError'
            not_found_error:
              $ref: '#/components/examples/NotFoundError'
            unauthorized_error:
              $ref: '#/components/examples/UnAuthorizedError'
            request_validation_error:
              $ref: '#/components/examples/RequestValidationError'
            schema_validation_error:
              $ref: '#/components/examples/SchemaValidationError'
    PaymentLinkError5XX:
      description: Default
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
          examples:
            internal_server_error:
              $ref: '#/components/examples/InternalServerError'
            service_unavailable_error:
              $ref: '#/components/examples/ServiceUnavailableError'
  examples:
    DefaultError:
      description: Default error
      value:
        error:
          name: bad_request
          message: Invalid request
    NotFoundError:
      description: Not Found error
      value:
        error:
          name: resource_not_found
          message: Resource Not Found
    UnAuthorizedError:
      description: Unauthorized Error
      value:
        error:
          name: unauthorized
          message: Unauthorized request
    RequestValidationError:
      description: Request Validation error example
      value:
        error:
          name: request_validation
          message: Validation error
        fields:
          field1:
            - reason: One of target and source amount must be set
          field2:
            - reason: One of target and source amount must be set
    SchemaValidationError:
      description: Schema validation error example
      value:
        error:
          name: schema_validation
          message: Error Validating Requests
        schema:
          - reason: >-
              The request body is defined as an object. However, it does not
              meet the schema requirements of the specification
            fix: >-
              Ensure that the object being submitted, matches the schema
              correctly
            schema_validation_error:
              - 'minLength: got 3, want 12'
    InternalServerError:
      description: Internal Server Error
      value:
        error:
          name: internal_server_error
          message: Internal Server Error
    ServiceUnavailableError:
      description: Service Unavailable Error
      value:
        error:
          name: service_unavailable
          message: Service Unavailable
  securitySchemes:
    Auth:
      type: http
      scheme: bearer
      description: Bearer Authentication

````